jQuery(function($) {
    if(window.location.hash == '#in8_netsuite_products'){
        $('select.ns_selector').chosen();
        $('select.wp_selector').chosen();
    }

    $('#tab_in8_netsuite_products').click(function () {
        $('select.ns_selector').unbind('chosen');
        $('select.ns_selector').chosen();
        $('select.wp_selector').unbind('chosen');
        $('select.wp_selector').chosen();
    });

    $('#save_wc_to_ns_mapping').on('click', '.add_line', function() {
        showLoading('...');
        var to = $(this).attr('data-to');
        $list = $('#' + to);
        var data = {
            action: "in8_wc_to_nc_mapping/line"
        };
        $.ajax({
            type: "post",
            dataType: "json",
            url: ajaxurl,
            data: data,
            success: function(response) {
                hideLoading();
                if (response.type == "success") {
                    $list.append(response.html);
                } else {
                    alert("Something went wrong");
                }
                $('select.ns_selector').unbind('chosen');
                $('select.ns_selector').chosen();
                $('select.wp_selector').unbind('chosen');
                $('select.wp_selector').chosen();
            }
        });
        return false;
    });
    $(document).on('submit', '#save_wc_to_ns_mapping', function() {
        showLoading('...');

        // process each line
        var $form = $(this);
        $form.find('.line').each(function(){
            var $line = $(this);
            var $wpSelector = $line.find('.wp_selector');
            var $wpOption = $wpSelector.find('option[value="'+$wpSelector.val()+'"]');
            var $nsSelector = $line.find('.ns_selector');
            var $nsOption = $nsSelector.find('option[value="'+$nsSelector.val()+'"]');
            var $field = null,
                $input = null,
                val = null;

            if( $wpSelector.val() == '_custom,userInput' || $wpSelector.val().indexOf('_custom,userInput,') == 0 ){
                $field = $wpSelector.parents('.field');
                $input = $field.find('.user_insert_text');

                val = '_custom,userInput,'+$input.val();
                $wpOption.val(val);
            }
            if( $wpSelector.val() == '_fixed,userInput' || $wpSelector.val().indexOf('_fixed,userInput,') == 0 ){
                $field = $wpSelector.parents('.field');
                $input = $field.find('.user_insert_text');

                val = '_fixed,userInput,'+$input.val();
                $wpOption.val(val);
            }
            
            if( $nsSelector.val() == '_item,userInput' || $nsSelector.val().indexOf('_item,userInput') == 0 ){
                $field = $nsSelector.parents('.field');
                $input = $field.find('.user_insert_text');

                val = '_item,userInput,'+$input.val();
                $nsOption.val(val);
            }
        });

        var data = $(this).serialize();
        $.ajax({
            type: "post",
            dataType: "json",
            url: ajaxurl,
            data: data,
            success: function(response) {
                hideLoading();
                if (response.type == "success") {
                    console.log('saved');
                } else {
                    alert("Something went wrong");
                }
            }
        });
        return false;
    });

    var lines = 100000;
    $(document).on('change', '.ns_selector, .wp_selector', function() {
        var $field = $(this).parents('.field');
        var $selector = $(this);
        var $line = $(this).parents('.line');

        if ($selector.val() == '_item,userInput' || $selector.val() == '_custom,userInput' || $selector.val() == '_fixed,userInput') {
            var type = ($selector.val() == '_item,userInput') ? 'ns' : 'wp';
            var reverseType = (type == 'ns') ? 'wp' : 'ns'

            $field.append('<input class="user_insert_text" value="" />');

            lines++;
        } else {
            $field.find('.user_insert_text').remove();
        }
    });
    $(document).on('click', '.line_remove', function() {
        var $line = $(this).parents('.line');
        $line.fadeOut(function() {
            $line.remove();
        });
        return false;
    });
});